using System;
using System.Collections;
using System.ComponentModel.Composition;
using System.Globalization;
using Tekla.Structures;
using Tekla.Structures.CustomPropertyPlugin;
using Tekla.Structures.Model;
using Tekla.Technology.Akit.UserScript;
using Tekla.Technology.Scripting;

[assembly: Compiler.Reference(@"%XSBIN%\plugins\Tekla.Structures.CustomPropertyPlugin.dll")]
[assembly: Compiler.Reference(@"c:\Windows\Microsoft.NET\assembly\GAC_MSIL\System.ComponentModel.Composition\v4.0_4.0.0.0__b77a5c561934e089\System.ComponentModel.Composition.dll")]

namespace Tekla.Technology.Akit.UserScript 
{
public class Script
    {
        public static void Run(Tekla.Technology.Akit.IScript akit)
        {
            
		}
    }
}
namespace PROFILE_NAME
{
	[Export(typeof(ICustomPropertyPlugin)), ExportMetadata("CustomProperty", "CUSTOM.PROFILE_NAME")]
	public class ElementWeight : ICustomPropertyPlugin
	{
		public double GetDoubleProperty(int objectId)
		{			
			return 0.0;
		}
		public int GetIntegerProperty(int objectId)
		{			
			return 0;
		}
		public string GetStringProperty(int objectId)
		{
			string result = "";
			Model model = new Model();
			Identifier iD = new Identifier(objectId);
			ModelObject modelObject = model.SelectModelObject(iD);
			Assembly assembly = null;
			string name = modelObject.GetType().Name;
			if (name != null)
			{
				if (!(name == "Assembly"))
				{
					if (name == "Beam" || name == "ContourPlate" || name == "PolyBeam")
					{
						Part part = modelObject as Part;
						assembly = part.GetAssembly();
					}
				}
				else
				{
					assembly = (modelObject as Assembly);
				}
				assembly.GetReportProperty("MAINPART.PROFILE",ref result);
			}
			return result;
		}
		
	}
	[Export(typeof(ICustomPropertyPlugin)), ExportMetadata("CustomProperty", "CUSTOM.MAINPART_NAME")]
	public class MAINPART_NAME : ICustomPropertyPlugin
	{
		public double GetDoubleProperty(int objectId)
		{			
			return 0.0;
		}
		public int GetIntegerProperty(int objectId)
		{			
			return 0;
		}
		public string GetStringProperty(int objectId)
		{
			string result = "";
			Model model = new Model();
			Identifier iD = new Identifier(objectId);
			ModelObject modelObject = model.SelectModelObject(iD);
			Assembly assembly = null;
			string name = modelObject.GetType().Name;
			if (name != null)
			{
				if (!(name == "Assembly"))
				{
					if (name == "Beam" || name == "ContourPlate" || name == "PolyBeam")
					{
						Part part = modelObject as Part;
						assembly = part.GetAssembly();
					}
				}
				else
				{
					assembly = (modelObject as Assembly);
				}
				assembly.GetReportProperty("MAINPART.PROFILE",ref result);
			}
			return result;
		}
		
	}
	[Export(typeof(ICustomPropertyPlugin)), ExportMetadata("CustomProperty", "CUSTOM.MAINPART_SMNAME")]
	public class MAINPART_SMNAME : ICustomPropertyPlugin
	{
		public double GetDoubleProperty(int objectId)
		{			
			return 0.0;
		}
		public int GetIntegerProperty(int objectId)
		{			
			return 0;
		}
		public string GetStringProperty(int objectId)
		{
			string result = "";
			Model model = new Model();
			Identifier iD = new Identifier(objectId);
			ModelObject modelObject = model.SelectModelObject(iD);
			Assembly assembly = null;
			string name = modelObject.GetType().Name;
			if (name != null)
			{
				if (!(name == "Assembly"))
				{
					if (name == "Beam" || name == "ContourPlate" || name == "PolyBeam")
					{
						Part part = modelObject as Part;
						assembly = part.GetAssembly();
					}
				}
				else
				{
					assembly = (modelObject as Assembly);
				}
				assembly.GetReportProperty("MAINPART.PROFILE",ref result);
                result = result.Replace("ДВУТAВР", "I");
                result = result.Replace("ДВУТАВР", "I");
				result=result.Replace("УГОЛОК","L");
				result=result.Replace("ШВЕЛЛЕР","[");
                //result = result + " xsteel@150";
			}
			return result;
		}
		
	}
    [Export(typeof(ICustomPropertyPlugin)), ExportMetadata("CustomProperty", "CUSTOM.IS_SELECT")]
    public class IS_SELECT : ICustomPropertyPlugin
    {
        public double GetDoubleProperty(int objectId)
        {
            return 0.0;
        }
        public int GetIntegerProperty(int objectId)
        {
            return 0;
        }
        public string GetStringProperty(int objectId)
        {
            string result = "";
            Model model = new Model();
            Identifier iD = new Identifier(objectId);
            ModelObject modelObject = model.SelectModelObject(iD);
            Assembly assembly = null;
            string name = modelObject.GetType().Name;
            if (name != null)
            {
                if (name == "Beam")
                {
                    Assembly beamAsm = (modelObject as Part).GetAssembly();
                    if (beamAsm != null)
                    {
                        Tekla.Structures.Model.UI.ModelObjectSelector SAS = new Tekla.Structures.Model.UI.ModelObjectSelector();
                        ModelObjectEnumerator SA = SAS.GetSelectedObjects();

                        while (SA.MoveNext())
                        {
                            if (SA.Current.Identifier.Equals(beamAsm.Identifier))
                            {
                                result = "выбрано";
                                break;
                            }
                        }
                    }
                }                
            }
            return result;
        }

    }
	[Export(typeof(ICustomPropertyPlugin)), ExportMetadata("CustomProperty", "CUSTOM.ROTATION")]
	public class ROTATION : ICustomPropertyPlugin
	{
		public double GetDoubleProperty(int objectId)
		{			
			return 0.0;
		}
		public int GetIntegerProperty(int objectId)
		{			
			return 0;
		}
		public string GetStringProperty(int objectId)
		{
			string result = "";
			Model model = new Model();
			Identifier iD = new Identifier(objectId);
			ModelObject modelObject = model.SelectModelObject(iD);
			string name = modelObject.GetType().Name;
			if (name != null)
			{
				if (name == "Beam")
				{
					result = (modelObject as Beam).Position.Rotation.ToString();
				}
				else
				{
					result = "NA";
				}				
			}
			return result;
		}
		
	}
}